package com.example.nto.controller;

import com.example.nto.dto.PassDTO;
import com.example.nto.entity.Users;
import com.example.nto.repository.UsersRepository;
import com.example.nto.service.PassService;
import lombok.RequiredArgsConstructor;
import org.springframework.data.domain.PageRequest;
import org.springframework.data.domain.Pageable;
import org.springframework.http.ResponseEntity;
import org.springframework.security.core.Authentication;
import org.springframework.web.bind.annotation.GetMapping;
import org.springframework.web.bind.annotation.RequestMapping;
import org.springframework.web.bind.annotation.RequestParam;
import org.springframework.web.bind.annotation.RestController;

import java.util.List;
import java.util.Objects;
import java.util.Optional;


@RestController
@RequestMapping("/api/passes")
@RequiredArgsConstructor
public class PassController {

    private final PassService passService;
    private final UsersRepository usersRepository;

    @GetMapping("/paginated/")
    public ResponseEntity<List<PassDTO>> getAllPassesAtUser(
            @RequestParam(required = false) String username,
            @RequestParam(defaultValue = "0") int page,
            @RequestParam(defaultValue = "10") int size,
            Authentication authentication
    ) {
        String name = authentication.getName();
        if (username == null) {
            username = authentication.getName();
        }
        Optional<Users> user = usersRepository.findByUsername(username);
        if (user.isPresent()) {
            if (Objects.equals(user.get().getAuthority().getAuthority(), "ROLE_ADMIN")) {
                Pageable pageable = PageRequest.of(page, size);
                return ResponseEntity.ok(passService.getAllPassesPaginated(pageable, username));
            }
            username = authentication.getName();
        }
        System.out.println(username);
        Pageable pageable = PageRequest.of(page, size);
        return ResponseEntity.ok(passService.getAllPassesPaginated(pageable, username));
    }
}