package com.example.nto.service.impl;

import com.example.nto.dto.PassDTO;
import com.example.nto.repository.PassRepository;
import com.example.nto.service.PassService;
import com.example.nto.util.PassMapper;
import lombok.RequiredArgsConstructor;
import org.springframework.data.domain.Pageable;
import org.springframework.stereotype.Service;

import java.util.List;
import java.util.Objects;
import java.util.stream.Collectors;

@Service
@RequiredArgsConstructor
public class PassServiceImpl implements PassService {

    private final PassRepository passRepository;


    @Override
    public List<PassDTO> getPassAtUser(long id) {
        return passRepository.findAll().stream()
                .filter(pass -> pass.getUsers().getId() == id)
                .map(PassMapper::convertDTO)
                .collect(Collectors.toList());
    }
    @Override
    public List<PassDTO> getAllPassesPaginated(Pageable pageable, String username) {
        return passRepository.findAll(pageable).stream()
                .filter(pass -> Objects.equals(pass.getUsers().getUsername(), username))
                .map(PassMapper::convertDTO)
                .collect(Collectors.toList());

    }
}